﻿using System;
using Utils;

namespace PluginSample2
{
	[Serializable]
	public class CustomDataParametersData : PropertyChangedNotifierCopyable<CustomDataParametersData>, ICloneable<CustomDataParametersData>
	{
		#region Attributes

		private bool _generateDailyChart;
		private bool _chartsOnlyOnOperatedDays;
		private bool _showOperations;
		private bool _executeInParallel;

		#endregion

		#region Properties

		public bool GenerateDailyChart
		{
			get
			{
				return _generateDailyChart;
			}
			set
			{
				if (_generateDailyChart != value)
				{
					_generateDailyChart = value;
					base.OnPropertyChanged("GenerateDailyChart");
				}
			}
		}

		public bool ChartsOnlyOnOperatedDays
		{
			get
			{
				return _chartsOnlyOnOperatedDays;
			}
			set
			{
				if (_chartsOnlyOnOperatedDays != value)
				{
					_chartsOnlyOnOperatedDays = value;
					base.OnPropertyChanged("ChartsOnlyOnOperatedDays");
				}
			}
		}

		public bool ShowOperations
		{
			get
			{
				return _showOperations;
			}
			set
			{
				if (_showOperations != value)
				{
					_showOperations = value;
					base.OnPropertyChanged("ShowOperations");
				}
			}
		}

		public bool ExecuteInParallel
		{
			get
			{
				return _executeInParallel;
			}
			set
			{
				if (_executeInParallel != value)
				{
					_executeInParallel = value;
					base.OnPropertyChanged("ExecuteInParallel");
				}
			}
		}

		#endregion

		#region ICloneable

		public CustomDataParametersData Clone()
		{
			return (CustomDataParametersData)this.MemberwiseClone();
		}

		#endregion
	}
}
