﻿using System.Diagnostics;
using Plugins.Base;

namespace PluginSample2
{
	[DebuggerDisplay("{base.Name}")]
	public sealed class DecisionEngineState : EngineState
	{
		#region Enum Values

		public static EngineState Stall { get; private set; }
		public static EngineState CountingUp { get; private set; }
		public static EngineState CountingDown { get; private set; }
		public static EngineState OnLongPossition { get; private set; }
		public static EngineState OnShortPossition { get; private set; }

		#endregion

		#region Public Methods

		static DecisionEngineState()
		{
			Stall = new DecisionEngineState("Stall");
			CountingUp = new DecisionEngineState("Counting Up");
			CountingDown = new DecisionEngineState("Counting Down");
			OnLongPossition = new DecisionEngineState("On Long Possition");
			OnShortPossition = new DecisionEngineState("On Short Possition");
		}

		private DecisionEngineState(string name) : base(name)
		{

		}

		#endregion
	}
}
