﻿using System.Diagnostics;

namespace Plugins.Base.Common
{
	[DebuggerDisplay("{this.Name}")]
	public class DecisionEngineStateBase
	{
		#region Properties

		public string Name { get; private set; }

		#endregion

		#region Enum Values

		public static DecisionEngineStateBase None { get; private set; }
		public static DecisionEngineStateBase WaitingOpen { get; private set; }
		public static DecisionEngineStateBase DayClosed { get; private set; }
		public static DecisionEngineStateBase AccessorDisconnected { get; private set; }

		#endregion

		#region Public Methods

		static DecisionEngineStateBase()
		{
			None = new DecisionEngineStateBase("None");
			WaitingOpen = new DecisionEngineStateBase("Waiting Open");
			DayClosed = new DecisionEngineStateBase("Day Closed");
			AccessorDisconnected = new DecisionEngineStateBase("Accessor Disconnected");
		}

		protected DecisionEngineStateBase(string name)
		{
			this.Name = name;
		}

		#endregion
	}
}
