﻿using System.Diagnostics;

namespace Plugins.Base
{
	[DebuggerDisplay("{this.Name}")]
	public class EngineState
	{
		#region Properties

		public string Name { get; private set; }

		#endregion

		#region Enum Values

		public static EngineState None { get; private set; }
		public static EngineState WaitingOpen { get; private set; }
		public static EngineState DayClosed { get; private set; }
		public static EngineState AccessorDisconnected { get; private set; }

		#endregion

		#region Public Methods

		static EngineState()
		{
			None = new EngineState("None");
			WaitingOpen = new EngineState("Waiting Open");
			DayClosed = new EngineState("Day Closed");
			AccessorDisconnected = new EngineState("Accessor Disconnected");
		}

		protected EngineState(string name)
		{
			this.Name = name;
		}

		#endregion
	}
}
