﻿using System;
using Utils;

namespace Plugins.UserControls
{
	[Serializable]
	public class StockSelectorData : PropertyChangedNotifierCopyable<StockSelectorData>, ICloneable<StockSelectorData>
	{
		#region Attributes

		private string _selectedStockName;

		#endregion

		#region Properties

		public string SelectedStockName
		{
			get
			{
				return _selectedStockName;
			}
			set
			{
				if (_selectedStockName != value)
				{
					_selectedStockName = value;
					base.OnPropertyChanged("SelectedStockName");
				}
			}
		}

		#endregion

		#region ICloneable

		public StockSelectorData Clone()
		{
			return (StockSelectorData)this.MemberwiseClone();
		}

		#endregion
    }
}
