﻿using System;
using System.Diagnostics;

namespace StockAccessors
{
	[DebuggerDisplay("Symbol = {Symbol}, Name = {Name}, Value = {LastValue}")]
	public class AccessorStockQuote
	{
        public DateTime Acquisition { get; set; }

		public string Symbol { get; set; }
		public string Name { get; set; }
		public decimal? LastValue { get; set; }
		public decimal? Difference { get; set; }
		public decimal? DifferencePercentage { get; set; }
		public decimal? BidValue { get; set; }
		public int? BidVolume { get; set; }
		public decimal? AskValue { get; set; }
		public int? AskVolume { get; set; }
		public decimal? Maximum { get; set; }
		public decimal? Minimum { get; set; }
		public int? Volume { get; set; }
		public decimal? PreviousValue { get; set; }
		public DateTime? Hour { get; set; }
		public DateTime? Expiry { get; set; }
		public int? OpenInterest { get; set; }
	}
}
