﻿using System;
using System.Collections.Generic;
using System.Xml.Linq;
using System.Linq;

namespace StockAccessors.Interdin.Model
{
	internal class FutureWebGroup : WebGroup
    {
        #region Properties

        public List<WebFuture> Futures { get; private set; }

        #endregion

        #region Public Methods

		public FutureWebGroup(XDocument data, DateTime creationTime) : base(data, creationTime)
		{
            this.Futures = new List<WebFuture>();
            this.FillStocks(data);
		}

        #endregion

        #region Private Methods

        private void FillStocks(XDocument data)
        {
			XElement[] groups = data.Descendants("tr").ToArray();

            for (int index = 0; index < groups.Count(); index++)
            {
                if (index > 2 && index < groups.Count() - 1)
                {
                    this.Futures.Add(new WebFuture(groups[index]) { Acquisition = base.CreationTime });
                }
            }
        }

        #endregion

	}
}
