﻿using System;
namespace StockAccessors.Interdin.Model
{
	internal class FuturesWebPage : WebPage
	{
		#region Properties

        public FutureWebGroup MeffGroup { get; private set; }
        public FutureWebGroup EurexGroup { get; private set; }
        public FutureWebGroup OtherIndexGroup { get; private set; }
        public FutureWebGroup EnergyAndMaterialsGroup { get; private set; }
        public FutureWebGroup CurrencyGroup { get; private set; }

		#endregion

		#region Public Methods

		public FuturesWebPage(string pageContents) : base(pageContents)
		{
            DateTime creationTime = DateTime.Now;

			this.MeffGroup = new FutureWebGroup(base.CreateGroupXml("MEFF"), creationTime);
			this.EurexGroup = new FutureWebGroup(base.CreateGroupXml("EUREX"), creationTime);
			this.OtherIndexGroup = new FutureWebGroup(base.CreateGroupXml("OTROS INDICES"), creationTime);
			this.EnergyAndMaterialsGroup = new FutureWebGroup(base.CreateGroupXml("ENERGIA Y MATERIAS PRIMAS"), creationTime);
			this.CurrencyGroup = new FutureWebGroup(base.CreateGroupXml("DIVISAS"), creationTime);
        }

		#endregion
	}
}
