﻿namespace StockAnalyst2.Chart
{
	internal class ChartData
	{
		#region Properties

		public Options Options { get; private set; }

		public BarSeries LastValueBar { get; private set; }
		public Series LastValue { get; private set; }
		public Series LastValuePercentage { get; private set; }
		public Series BidAskAverage { get; private set; }
		public BandSeries BidAsk { get; private set; }
		public Series SMA1 { get; private set; }
		public Series SMA2 { get; private set; }
		public Series SMA3 { get; private set; }
		public Series Stochastic { get; private set; }
		public Series Gap { get; private set; }
		public Series Trix { get; private set; }
		public Series TrixRatioOfChange { get; private set; }
		public Series Volume { get; private set; }
		public Series TotalVolume { get; private set; }
		public Series AverageVolume { get; private set; }

		#endregion

		#region Public Methods

		public ChartData()
		{
			this.Options = DefaultOptions.Get();

			this.LastValueBar = new BarSeries();
			this.LastValue = new Series();
			this.LastValuePercentage = new Series();
			this.BidAskAverage = new Series();
			this.BidAsk = new BandSeries();
			this.SMA1 = new Series();
			this.SMA2 = new Series();
			this.SMA3 = new Series();
			this.Stochastic = new Series();
			this.Gap = new Series();
			this.Trix = new Series();
			this.TrixRatioOfChange = new Series();
			this.Volume = new Series();
			this.TotalVolume = new Series();
			this.AverageVolume = new Series();
		}

		#endregion
	}
}
