﻿using System.Windows.Media;

namespace StockAnalyst2.Chart
{
	internal static class DefaultOptions
	{
		public static Options Get()
		{
			Options result = new Options();

			result.DataSource = ChartSource.LastValue;

			result.LastValue.IsEnabled = true;
			result.LastValue.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0x05, 0xFE, 0xFE));
			result.LastValue.Thickness = 1;
			result.LastValue.DrawArea = true;
			result.LastValue.AreaColor = new SolidColorBrush(Color.FromArgb(0x40, 0x05, 0xFE, 0xFE));

			result.BidAskAverage.IsEnabled = false;
			result.BidAskAverage.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0x55, 0x7E, 0xFE));
			result.BidAskAverage.Thickness = 1;
			result.BidAskAverage.DrawArea = true;
			result.BidAskAverage.AreaColor = new SolidColorBrush(Color.FromArgb(0x40, 0x55, 0x7E, 0xFE));

			result.Bid.IsEnabled = false;
			result.Bid.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0xF7, 0x03, 0x02));
			result.Bid.Thickness = 1;
			result.Bid.DrawArea = true;
			result.Bid.AreaColor = new SolidColorBrush(Color.FromArgb(0x40, 0xFF, 0xFF, 0xFF));

			result.Ask.IsEnabled = false;
			result.Ask.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0x00, 0xF0, 0x00));
			result.Ask.Thickness = 1;
			result.Ask.DrawArea = true;
			result.Ask.AreaColor = new SolidColorBrush(Color.FromArgb(0x40, 0xFF, 0xFF, 0xFF));

			result.SMA1.IsEnabled = true;
			result.SMA1.Parameter1Value = 240;
			result.SMA1.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0x73, 0xF2, 0x49));
			result.SMA1.Thickness = 2;

			result.SMA2.IsEnabled = false;
			result.SMA2.Parameter1Value = 480;
			result.SMA2.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0xBB, 0x4D, 0xEC));
			result.SMA2.Thickness = 2;

			result.SMA3.IsEnabled = false;
			result.SMA3.Parameter1Value = 2040;
			result.SMA3.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0xFF, 0xC2, 0x04));
			result.SMA3.Thickness = 2;

			result.Stochastic.IsEnabled = false;
			result.Stochastic.Parameter1Value = 840;
			result.Stochastic.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0xC0, 0x42, 0xEF));
			result.Stochastic.Thickness = 2;
			result.Stochastic.DrawArea = true;
			result.Stochastic.AreaColor = new SolidColorBrush(Color.FromArgb(0x40, 0xC0, 0x42, 0xEF));

			result.Gap.IsEnabled = true;
			result.Gap.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0x00, 0x70, 0xFF));
			result.Gap.Thickness = 1;

			result.Trix.IsEnabled = true;
			result.Trix.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0xBB, 0xEC, 0x64));

			result.TrixChangeRatio.IsEnabled = true;
			result.TrixChangeRatio.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0xDF, 0x31, 0x23));

			result.Volume.IsEnabled = true;
			result.Volume.Parameter1Value = 150;
			result.Volume.Color = new LinearGradientBrush(Color.FromArgb(0xFF, 0x02, 0xBA, 0xEC), Color.FromArgb(0xFF, 0x00, 0x08, 0xB5), 90.0);

			result.TotalVolume.IsEnabled = false;
			result.TotalVolume.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0xBB, 0xEC, 0x64));
			result.TotalVolume.Thickness = 2;
			result.TotalVolume.DrawArea = true;
			result.TotalVolume.AreaColor = new SolidColorBrush(Color.FromArgb(0x40, 0xBB, 0xEC, 0x64));

			result.AverageVolume.IsEnabled = false;
			result.AverageVolume.Color = new SolidColorBrush(Color.FromArgb(0xFF, 0xDF, 0x31, 0x23));
			result.AverageVolume.Parameter1Value = 3;
			result.AverageVolume.Thickness = 2;
			result.AverageVolume.DrawArea = true;
			result.AverageVolume.AreaColor = new SolidColorBrush(Color.FromArgb(0x40, 0xDF, 0x31, 0x23));

			return result;
		}

	}
}
