using StockModel;
using Utils;

namespace StockAnalyst2.StockGrid
{
	internal class AddRowMessage : Message
	{
		#region Properties
		
		public string GroupName {get; private set;}
		public string StockName {get; private set;}
		public string StockSymbol {get; private set;}
		public QuotationDailyInfo DailyInfo {get; private set;}
		
		#endregion
		
		#region Public Methods

		public AddRowMessage(string groupName, string stockName, string stockSymbol, QuotationDailyInfo dailyInfo) : base (RowManagerMessageType.AddRow)
		{
			this.GroupName = groupName;
			this.StockName = stockName;
			this.StockSymbol = stockSymbol;
			this.DailyInfo = dailyInfo;
		}
		
		#endregion
	}
}