﻿using System;
using System.Diagnostics;

namespace StockModel
{
    [DebuggerDisplay("Name = {Item.Id.Name}, Date Added = {DateAdded}")]
    [Serializable]
    public class StockGroupItem
    {
        #region Properties

        public Stock Item { get; private set; }
        public DateTime DateAdded { get; set; }
        public DateTime? DateRemoved { get; set; }

        #endregion

        #region Public Methods

        public StockGroupItem(Stock item)
        {
            this.Item = item;
            this.DateAdded = DateTime.Now;
            this.DateRemoved = null;
        }

		public StockGroupItem(Stock item, DateTime added, DateTime? removed)
        {
            this.Item = item;
            this.DateAdded = added;
            this.DateRemoved = removed;
        }

        #endregion
    }
}
