﻿using StockModel;
using TechnicalIndicators.Points;
using Utils;

namespace TechnicalIndicators.QuotationBased
{
	public class BidAskAverageGenerator : GeneratorBase<Quotation, DatedSeriePoint>
	{
		#region Attributes

		private bool _skipPreOpenQuotes;

		#endregion

		#region Public Methods

		public BidAskAverageGenerator(ObservableCollection2<DatedSeriePoint> destination) : base(destination)
		{
		}

		public void Configure(bool skipPreOpenQuotes)
		{
			_skipPreOpenQuotes = skipPreOpenQuotes;
		}

		protected override DatedSeriePoint CreatePoint(Quotation quotation)
		{
			if (_skipPreOpenQuotes && quotation.Volume == 0)
			{
				return null;
			}
			else
			{
				return quotation.Sellers[0].Value == 0 || quotation.Buyers[0].Value == 0 ? null : new DatedSeriePoint(quotation.Date, (quotation.Sellers[0].Value + quotation.Buyers[0].Value) / 2);
			}
		}

		#endregion
	}
}
