﻿using StockModel;
using TechnicalIndicators.Points;
using Utils;

namespace TechnicalIndicators.QuotationBased
{
	public class LastValueGenerator : GeneratorBase<Quotation, DatedSeriePoint>
	{
		#region Attributes

		private bool _skipPreOpenQuotes;

		#endregion

		#region Public Methods
		
		public LastValueGenerator()
		{
		}

		public LastValueGenerator(ObservableCollection2<DatedSeriePoint> destination) : base(destination)
		{
		}

		public void Configure(bool skipPreOpenQuotes)
		{
			_skipPreOpenQuotes = skipPreOpenQuotes;
		}

		protected override DatedSeriePoint CreatePoint(Quotation quotation)
		{
			if (_skipPreOpenQuotes && quotation.Volume == 0)
			{
				return null;
			}
			else
			{
				return new DatedSeriePoint(quotation.Date, quotation.Value);	
			}
		}

		#endregion
	}
}
