﻿using System.Windows;

namespace Utils.Wpf
{
	public class BindingProxy : Freezable
	{
		#region Dependence Properties

		// Using a DependencyProperty as the backing store for Data.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty DataProperty = DependencyProperty.Register("Data", typeof(object), typeof(BindingProxy), new UIPropertyMetadata(null));

		public object Data
		{
			get
			{
				return this.GetValue(DataProperty);
			}
			set
			{
				this.SetValue(DataProperty, value);
			}
		}

		#endregion

		#region Overrides of Freezable

		protected override Freezable CreateInstanceCore()
		{
			return new BindingProxy();
		}

		#endregion
	}
}
