﻿using System;
using System.Windows.Data;

namespace Utils.Wpf.Converters
{
	public class EnumToBooleanConverter : IValueConverter
	{
		#region IValueConverter Members

		public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			string parameterString = parameter as string;

			if (parameterString == null)
			{
				return Binding.DoNothing;
			}
			else if (!Enum.IsDefined(value.GetType(), value))
			{
				return Binding.DoNothing;
			}
			else
			{
				object parameterValue = Enum.Parse(value.GetType(), parameterString);
				return parameterValue.Equals(value);
			}
		}

		public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			string parameterString = parameter as string;
			
			if (parameterString == null || !(bool)value)
			{
				return Binding.DoNothing;
			}
			else
			{
				return Enum.Parse(targetType, parameterString);	
			}
		}

		#endregion
	}
}