﻿using System.Windows;
using System.Windows.Media;

namespace Utils.Wpf
{
	public class LabelState : FrameworkElement
	{
		#region Properties

		public int Id { get; set; }

		#endregion

		#region Dependence Properties

		public static DependencyProperty TextProperty = DependencyProperty.Register("Text", typeof(string), typeof(LabelState));

		public string Text
		{
			get
			{
				return (string)base.GetValue(TextProperty);
			}
			set
			{
				base.SetValue(TextProperty, value);
			}
		}

		public static DependencyProperty BrushProperty = DependencyProperty.Register("Brush", typeof(Brush), typeof(LabelState));

		public Brush Brush
		{
			get
			{
				return (Brush)base.GetValue(BrushProperty);
			}
			set
			{
				base.SetValue(BrushProperty, value);
			}
		}

		public static DependencyProperty BorderBrushProperty = DependencyProperty.Register("BorderBrush", typeof(Brush), typeof(LabelState));

		public Brush BorderBrush
		{
			get
			{
				return (Brush)base.GetValue(BorderBrushProperty);
			}
			set
			{
				base.SetValue(BorderBrushProperty, value);
			}
		}

		public static DependencyProperty EnableBlinkProperty = DependencyProperty.Register("EnableBlink", typeof(bool), typeof(LabelState));

		public bool EnableBlink
		{
			get
			{
				return (bool)base.GetValue(EnableBlinkProperty);
			}
			set
			{
				base.SetValue(EnableBlinkProperty, value);
			}
		}

		#endregion
	}
}
